# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/10_join.ipynb.

# %% auto 0
__all__ = ['VArgs', 'tovargs', 'charjoin', 'dotstr', 'dashstr', 'ustr', 'dustr', 'nilstr']

# %% ../nbs/10_join.ipynb 4
from typing import Any, Union, TypeAlias
from atyp import StrQ, StrGuard
from nchr import DOT, DASH, U1, U2, NIL
from chck import istuple

# %% ../nbs/10_join.ipynb 6
VArgs: TypeAlias = Union[Any, tuple]

def tovargs(*args: VArgs) -> tuple:
    if len(args) == 1 and istuple(args[0]): return tovargs(*args[0])
    return args if istuple(args) else (args, )

# %% ../nbs/10_join.ipynb 7
def charjoin(char: str, *strs) -> str: 
    return char.join(tuple(tovargs(strs)))

def dotstr(*strs) -> str:  return charjoin(DOT, *strs)

def dashstr(*strs) -> str: return charjoin(DASH, *strs)

def ustr(*strs) -> str:    return charjoin(U1, *strs)

def dustr(*strs) -> str:   return charjoin(U2, *strs)

def nilstr(*strs) -> str:  return charjoin(NIL, *strs)
