# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/05_snek.ipynb.

# %% auto 0
__all__ = ['snek', 'py_to_snake']

# %% ../nbs/05_snek.ipynb 4
from nchr import U1
from regsyn import globsyn

from .repl import joinall
from .pttn import WORDS_TO_SNAKE_WITH_UPPERCASE, SNAKE_PATTERNS

# %% ../nbs/05_snek.ipynb 6
@globsyn({'snake', 'to_snake', 'snakify', 'snakify'})
def snek(s: str) -> str:
    '''Convert a string to snake_case'''
    return joinall(s, WORDS_TO_SNAKE_WITH_UPPERCASE, U1).lower()

    
def py_to_snake(s: str) -> str:    
    '''Convert a string to snake_case without using `re`'''
    _precap = [f'{U1}{c.lower()}' if c.isupper() else c for c in s]
    return ''.join(_precap).lstrip(U1)
